"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _segmentPanel = _interopRequireDefault(require("./segment-panel"));

var _antd = require("antd");

var _constants = require("@mlvis/mlvis-common/constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _templateObject4() {
  var data = _taggedTemplateLiteral(["\n      margin-top: 12px;\n    "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  justify-content: space-between;\n\n  ", ";\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n      background: #fff;\n      padding: 12px;\n    "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  color: #666;\n  font-family: ff-clan-web-pro, 'Helvetica Neue', Helvetica, sans-serif;\n  font-size: 12px;\n\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var SegmentPanelListContainer = _styledComponents["default"].div(_templateObject(), function (props) {
  return props.withPadding && (0, _styledComponents.css)(_templateObject2());
});

var Footer = _styledComponents["default"].div(_templateObject3(), function (props) {
  return props.marginTop && (0, _styledComponents.css)(_templateObject4());
}); // UTILITIES
// generate mono-increasing Id, unique for single client


var randomId = function randomId() {
  return Date.now().toString(36).substr(2, 7);
};

var SegmentPanelList =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(SegmentPanelList, _PureComponent);

  function SegmentPanelList() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, SegmentPanelList);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(SegmentPanelList)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      // create one segment with a random Id as default
      segments: [{
        key: randomId()
      }],
      segmentsUpdated: false
    });

    _defineProperty(_assertThisInitialized(_this), "_handleUpdateFilters", function (key, filters) {
      var updatedSegments = _this.state.segments.filter(function (segment) {
        return segment.key !== key;
      }).concat({
        key: key,
        filters: filters
      }).sort(function (a, b) {
        return a.key.localeCompare(b.key);
      });

      _this.setState({
        segments: updatedSegments,
        segmentsUpdated: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "_handleUpdateSegments", function () {
      _this.props.updateSegmentFilters(_this.state.segments);

      _this.setState({
        segmentsUpdated: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "_handleAppendSegment", function () {
      var segments = _this.state.segments;

      _this.setState({
        segments: segments.concat({
          key: randomId()
        })
      });
    });

    _defineProperty(_assertThisInitialized(_this), "_handleRemoveSegment", function (key) {
      var segments = _this.state.segments;

      _this.setState({
        segments: segments.filter(function (segment) {
          return segment.key !== key;
        })
      });
    });

    _defineProperty(_assertThisInitialized(_this), "_renderSegmentPanels", function () {
      var attributes = _this.props.attributes;
      var segments = _this.state.segments;

      if (!segments || !segments.length) {
        return null;
      }

      return segments.map(function (segment) {
        return _react["default"].createElement(_segmentPanel["default"], {
          key: segment.key,
          attributes: attributes,
          segment: segment,
          removeSegment: _this._handleRemoveSegment,
          updateFilters: function updateFilters(filters) {
            return _this._handleUpdateFilters(segment.key, filters);
          }
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "_renderFooter", function () {
      var _this$state = _this.state,
          segments = _this$state.segments,
          segmentsUpdated = _this$state.segmentsUpdated;
      var hasSegment = (segments || []).length > 0;
      var appendButtonType = hasSegment ? 'default' : 'primary';
      var updateButtonType = hasSegment && segmentsUpdated ? 'primary' : 'default';
      return (// add padding if segment list is not empty
        _react["default"].createElement(Footer, {
          marginTop: hasSegment
        }, _react["default"].createElement(_antd.Button, {
          type: appendButtonType,
          icon: "plus",
          size: "small",
          onClick: _this._handleAppendSegment
        }, "Add Segment"), _react["default"].createElement(_antd.Button, {
          type: updateButtonType,
          icon: "check",
          size: "small",
          onClick: _this._handleUpdateSegments
        }, "Update"))
      );
    });

    return _this;
  }

  _createClass(SegmentPanelList, [{
    key: "render",
    value: function render() {
      var attributes = this.props.attributes;

      if (!attributes || !attributes.length) {
        return null;
      }

      return _react["default"].createElement(SegmentPanelListContainer, {
        withPadding: true
      }, this._renderSegmentPanels(), this._renderFooter());
    }
  }]);

  return SegmentPanelList;
}(_react.PureComponent);

exports["default"] = SegmentPanelList;

_defineProperty(SegmentPanelList, "propTypes", {
  attributes: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    // attribute name, required
    key: _propTypes["default"].string.isRequired,
    type: _propTypes["default"].PropTypes.oneOf([_constants.FEATURE_TYPE.BOOLEAN, _constants.FEATURE_TYPE.CATEGORICAL, _constants.FEATURE_TYPE.NUMERICAL]),
    // attribute values, optional, feature distribution will be skipped if null or empty
    values: _propTypes["default"].arrayOf(_propTypes["default"].any),
    // distribution: value histogram, optional, will be derived if values is given
    distribution: _propTypes["default"].arrayOf(_propTypes["default"].any),
    // [min, ..., max] for numerical attribute and [enums] for categorical attribute
    domain: _propTypes["default"].arrayOf(_propTypes["default"].any)
  })).isRequired,
  // callback function to popup changes in filter
  updateSegmentFilters: _propTypes["default"].func
});

_defineProperty(SegmentPanelList, "defaultProps", {
  attributes: [],
  updateSegmentFilters: function updateSegmentFilters() {}
});
//# sourceMappingURL=segment-panel-list.js.map