"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _antd = require("antd");

var _segmentFilterDistribution = _interopRequireDefault(require("./segment-filter-distribution"));

var _constants = require("@mlvis/mlvis-common/constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  color: #666;\n  font-size: 12px;\n  overflow-wrap: break-word;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  &:not(:last-child) {\n    margin-bottom: 16px;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var SegmentFilterContainer = _styledComponents["default"].div(_templateObject());

var SegmentFilterKey = _styledComponents["default"].div(_templateObject2());

var round = function round(n) {
  var decimal = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 2;
  var scale = Math.pow(10, decimal);
  return Math.round(n * scale) / scale;
};

var SegmentFilter =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(SegmentFilter, _PureComponent);

  function SegmentFilter() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, SegmentFilter);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(SegmentFilter)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      selectedDomain: []
    });

    _defineProperty(_assertThisInitialized(_this), "_handleUpdateFilterValue", function (value) {
      var _this$props = _this.props,
          filter = _this$props.filter,
          updateFilter = _this$props.updateFilter;

      _this.setState({
        selectedDomain: value
      }, updateFilter(_objectSpread({}, filter, {
        value: value
      })));
    });

    _defineProperty(_assertThisInitialized(_this), "_renderFilterControl", function () {
      var _this$props2 = _this.props,
          attribute = _this$props2.attribute,
          filter = _this$props2.filter;

      if (!attribute || !attribute.domain || !attribute.domain.length) {
        return null;
      }

      var min = round(attribute.domain[0]);
      var max = round(attribute.domain[attribute.domain.length - 1]);

      switch (attribute.type) {
        case _constants.FEATURE_TYPE.NUMERICAL:
          return _react["default"].createElement(_antd.Slider, {
            key: filter.key,
            range: true,
            min: min,
            max: max,
            defaultValue: [min, max],
            style: {
              margin: '0px 4px 4px 4px'
            },
            onChange: _this._handleUpdateFilterValue
          });

        case _constants.FEATURE_TYPE.CATEGORICAL:
          return _react["default"].createElement(_antd.Select, {
            key: filter.key,
            mode: "multiple",
            size: "small",
            style: {
              width: '100%'
            },
            placeholder: "Please select",
            onChange: _this._handleUpdateFilterValue
          }, attribute.domain.map(function (d) {
            return _react["default"].createElement(_antd.Select.Option, {
              key: d
            }, d);
          }));

        default:
          return _react["default"].createElement("div", null, "Feature type ".concat(attribute.type, " not supported."));
      }
    });

    return _this;
  }

  _createClass(SegmentFilter, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          attribute = _this$props3.attribute,
          filter = _this$props3.filter;

      if (!attribute || !filter) {
        return null;
      }

      return _react["default"].createElement(SegmentFilterContainer, null, _react["default"].createElement(SegmentFilterKey, null, filter.key), _react["default"].createElement(_segmentFilterDistribution["default"], {
        attribute: attribute,
        domainAlt: this.state.selectedDomain
      }), this._renderFilterControl());
    }
  }]);

  return SegmentFilter;
}(_react.PureComponent);

exports["default"] = SegmentFilter;

_defineProperty(SegmentFilter, "propTypes", {
  attribute: _propTypes["default"].shape({
    key: _propTypes["default"].string.isRequired,
    values: _propTypes["default"].arrayOf(_propTypes["default"].any),
    domain: _propTypes["default"].arrayOf(_propTypes["default"].any)
  }).isRequired,
  filter: _propTypes["default"].shape({
    key: _propTypes["default"].string.isRequired,
    value: _propTypes["default"].arrayOf(_propTypes["default"].any),
    type: _propTypes["default"].string.isRequired
  }).isRequired,
  updateFilter: _propTypes["default"].func
});

_defineProperty(SegmentFilter, "defaultProps", {
  attribute: null,
  filter: null,
  updateFilter: function updateFilter() {}
});
//# sourceMappingURL=segment-filter.js.map