"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _constants = require("@mlvis/mlvis-common/constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// TODO make responsive
var DEFAULT_WIDTH = 192;
var DEFAULT_HEIGHT = 40;
var COLOR = {
  INCLUDE: '#1690FF',
  EXCLUDE: '#CCC'
};

var getColor = function getColor(value, domain, type) {
  if (!domain || !domain.length) {
    return COLOR.INCLUDE;
  }

  switch (type) {
    case _constants.FEATURE_TYPE.NUMERICAL:
      return domain[0] <= value && value <= domain[1] ? COLOR.INCLUDE : COLOR.EXCLUDE;

    case _constants.FEATURE_TYPE.CATEGORICAL:
      return domain.includes(value) ? COLOR.INCLUDE : COLOR.EXCLUDE;

    default:
      return COLOR.INCLUDE;
  }
};

var SegmentFilterDistribution =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(SegmentFilterDistribution, _PureComponent);

  function SegmentFilterDistribution() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, SegmentFilterDistribution);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(SegmentFilterDistribution)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "_renderDistribution", function () {
      var _this$props = _this.props,
          width = _this$props.width,
          height = _this$props.height,
          attribute = _this$props.attribute,
          domainAlt = _this$props.domainAlt;

      if (!attribute) {
        return null;
      }

      var domain = attribute.domain,
          distribution = attribute.distribution,
          type = attribute.type; // TODO use domain and distribution to generate hovered tooltip

      var dx = width / domain.length;
      var dy = height;
      var maxValue = Math.max.apply(Math, _toConsumableArray(distribution));
      var normalizedDistribution = distribution.map(function (d) {
        return d / maxValue;
      });
      var rects = normalizedDistribution.map(function (d, i) {
        var color = getColor(domain[i], domainAlt, type);
        return _react["default"].createElement("rect", {
          key: i,
          x: dx * i,
          rx: 2,
          ry: 2,
          width: dx,
          height: dy * d,
          fill: color
        });
      });
      return _react["default"].createElement("g", {
        transform: "translate(0, ".concat(height, ") scale(1,-1)")
      }, rects);
    });

    return _this;
  }

  _createClass(SegmentFilterDistribution, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          width = _this$props2.width,
          height = _this$props2.height;

      if (width <= 0 || height <= 0) {
        return null;
      }

      return _react["default"].createElement("svg", {
        width: width,
        height: height
      }, this._renderDistribution());
    }
  }]);

  return SegmentFilterDistribution;
}(_react.PureComponent);

exports["default"] = SegmentFilterDistribution;

_defineProperty(SegmentFilterDistribution, "propTypes", {
  width: _propTypes["default"].number.isRequired,
  height: _propTypes["default"].number.isRequired,
  attribute: _propTypes["default"].shape({
    key: _propTypes["default"].string.isRequired,
    distribution: _propTypes["default"].arrayOf(_propTypes["default"].number),
    domain: _propTypes["default"].arrayOf(_propTypes["default"].any),
    type: _propTypes["default"].string.isRequired
  }).isRequired,
  // an alternative domain used for highlighting
  domainAlt: _propTypes["default"].arrayOf(_propTypes["default"].any)
});

_defineProperty(SegmentFilterDistribution, "defaultProps", {
  width: DEFAULT_WIDTH,
  height: DEFAULT_HEIGHT,
  attribute: null
});
//# sourceMappingURL=segment-filter-distribution.js.map