"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _segmentFilter = _interopRequireDefault(require("./segment-filter"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  background-color: #f8f8f8;\n  padding: 12px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var SegmentFilterListContainer = _styledComponents["default"].div(_templateObject());

var SegmentFilterList =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(SegmentFilterList, _PureComponent);

  function SegmentFilterList() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, SegmentFilterList);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(SegmentFilterList)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "_handleUpdateFilter", function (filter) {
      var updatedFilters = _this.props.filters // replace filter with the new one
      .filter(function (f) {
        return f.key !== filter.key;
      }).concat(filter).sort(function (a, b) {
        return a.key.localeCompare(b.key);
      });

      _this.props.updateFilters(updatedFilters);
    });

    return _this;
  }

  _createClass(SegmentFilterList, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          attributes = _this$props.attributes,
          filters = _this$props.filters;

      if (!filters || !filters.length) {
        return null;
      }

      var filterControls = filters.map(function (filter) {
        var attribute = attributes.find(function (d) {
          return d.key === filter.key;
        });
        return _react["default"].createElement(_segmentFilter["default"], {
          key: filter.key,
          attribute: attribute,
          filter: filter,
          updateFilter: _this2._handleUpdateFilter
        });
      });
      return _react["default"].createElement(SegmentFilterListContainer, null, filterControls);
    }
  }]);

  return SegmentFilterList;
}(_react.PureComponent);

exports["default"] = SegmentFilterList;

_defineProperty(SegmentFilterList, "propTypes", {
  attributes: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    key: _propTypes["default"].string.isRequired,
    values: _propTypes["default"].arrayOf(_propTypes["default"].any),
    domain: _propTypes["default"].arrayOf(_propTypes["default"].any)
  })).isRequired,
  filters: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    key: _propTypes["default"].string.isRequired,
    value: _propTypes["default"].arrayOf(_propTypes["default"].any),
    type: _propTypes["default"].string
  })).isRequired,
  updateFilters: _propTypes["default"].func
});

_defineProperty(SegmentFilterList, "defaultProps", {
  attributes: null,
  filters: null,
  updateFilters: function updateFilters() {}
});
//# sourceMappingURL=segment-filter-list.js.map