"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _antd = require("antd");

var _segmentFilterList = _interopRequireDefault(require("./segment-filter-list"));

var _constants = require("@mlvis/mlvis-common/constants");

var _FEATURE_TYPE_TO_FILT;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  border-bottom: 1px solid #e8e8e8;\n  height: 48px;\n  padding: 12px 16px;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  background: #fff;\n  border-radius: 2px;\n  box-shadow: 0 1px 4px rgba(0, 0, 0, 0.2);\n  margin-bottom: 12px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FEATURE_TYPE_TO_FILTER_TYPE_MAP = (_FEATURE_TYPE_TO_FILT = {}, _defineProperty(_FEATURE_TYPE_TO_FILT, _constants.FEATURE_TYPE.BOOLEAN, _constants.FILTER_TYPE.INCLUDE), _defineProperty(_FEATURE_TYPE_TO_FILT, _constants.FEATURE_TYPE.CATEGORICAL, _constants.FILTER_TYPE.INCLUDE), _defineProperty(_FEATURE_TYPE_TO_FILT, _constants.FEATURE_TYPE.NUMERICAL, _constants.FILTER_TYPE.RANGE), _FEATURE_TYPE_TO_FILT);

var SegmentPanelContainer = _styledComponents["default"].div(_templateObject());

var SegmentPanelHeader = _styledComponents["default"].div(_templateObject2());

var AttributeTag = function AttributeTag(_ref) {
  var type = _ref.type;

  switch (type) {
    case _constants.FEATURE_TYPE.NUMERICAL:
      return _react["default"].createElement(_antd.Tag, {
        color: "blue"
      }, _constants.FEATURE_TYPE.NUMERICAL);

    case _constants.FEATURE_TYPE.CATEGORICAL:
      return _react["default"].createElement(_antd.Tag, {
        color: "volcano"
      }, _constants.FEATURE_TYPE.CATEGORICAL);

    case _constants.FEATURE_TYPE.BOOLEAN:
      return _react["default"].createElement(_antd.Tag, {
        color: "purple"
      }, _constants.FEATURE_TYPE.BOOLEAN);

    default:
      return _react["default"].createElement(_antd.Tag, null, "unkown");
  }
};

var SegmentPanel =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(SegmentPanel, _PureComponent);

  function SegmentPanel() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, SegmentPanel);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(SegmentPanel)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "_handleAddRemoveFilters", function (newKeys) {
      var _this$props = _this.props,
          attributes = _this$props.attributes,
          _this$props$segment$f = _this$props.segment.filters,
          filters = _this$props$segment$f === void 0 ? [] : _this$props$segment$f;
      var oldKeys = filters.map(function (f) {
        return f.key;
      });
      var keysToAppend = newKeys.filter(function (key) {
        return !oldKeys.includes(key);
      });
      var keysToRemove = oldKeys.filter(function (key) {
        return !newKeys.includes(key);
      });
      var filtersToAppend = keysToAppend.map(function (key) {
        var _attributes$find = attributes.find(function (attr) {
          return attr.key === key;
        }),
            attributeType = _attributes$find.type;

        return {
          key: key,
          keyIndex: 0,
          type: FEATURE_TYPE_TO_FILTER_TYPE_MAP[attributeType]
        };
      });
      var updatedFilters = filters.filter(function (f) {
        return !keysToRemove.includes(f.key);
      }).concat(filtersToAppend).sort(function (a, b) {
        return a.key.localeCompare(b.key);
      });

      _this.props.updateFilters(updatedFilters);
    });

    _defineProperty(_assertThisInitialized(_this), "_renderSegmentPanelHeader", function () {
      var _this$props2 = _this.props,
          attributes = _this$props2.attributes,
          segment = _this$props2.segment,
          removeSegment = _this$props2.removeSegment;
      var options = attributes.map(function (attr) {
        return _react["default"].createElement(_antd.Select.Option, {
          key: attr.key
        }, _react["default"].createElement("span", null, _react["default"].createElement(AttributeTag, {
          type: attr.type
        }), attr.key));
      });
      return _react["default"].createElement(SegmentPanelHeader, null, _react["default"].createElement(_antd.Input.Group, {
        compact: true
      }, _react["default"].createElement(_antd.Select, {
        autoFocus: true,
        maxTagCount: 0,
        mode: "multiple",
        size: "small",
        dropdownMatchSelectWidth: false,
        style: {
          width: '82%'
        },
        placeholder: "Select attributes",
        onChange: _this._handleAddRemoveFilters
      }, options), _react["default"].createElement(_antd.Button, {
        size: "small",
        icon: "delete",
        onClick: function onClick() {
          return removeSegment(segment.key);
        }
      })));
    });

    _defineProperty(_assertThisInitialized(_this), "_renderSegmentPanelContent", function () {
      var _this$props3 = _this.props,
          _this$props3$attribut = _this$props3.attributes,
          attributes = _this$props3$attribut === void 0 ? [] : _this$props3$attribut,
          _this$props3$segment$ = _this$props3.segment.filters,
          filters = _this$props3$segment$ === void 0 ? [] : _this$props3$segment$,
          updateFilters = _this$props3.updateFilters;
      return _react["default"].createElement(_segmentFilterList["default"], {
        attributes: attributes,
        filters: filters,
        updateFilters: updateFilters
      });
    });

    return _this;
  }

  _createClass(SegmentPanel, [{
    key: "render",
    value: function render() {
      var segment = this.props.segment;

      if (!segment) {
        return null;
      }

      return _react["default"].createElement(SegmentPanelContainer, null, this._renderSegmentPanelHeader(segment), this._renderSegmentPanelContent());
    }
  }]);

  return SegmentPanel;
}(_react.PureComponent);

exports["default"] = SegmentPanel;

_defineProperty(SegmentPanel, "propTypes", {
  attributes: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    key: _propTypes["default"].string.isRequired
  })).isRequired,
  segment: _propTypes["default"].object.isRequired,
  removeSegment: _propTypes["default"].func,
  updateFilters: _propTypes["default"].func
});

_defineProperty(SegmentPanel, "defaultProps", {
  attributes: [],
  segment: null,
  removeSegment: function removeSegment() {},
  updateFilters: function updateFilters() {}
});
//# sourceMappingURL=segment-panel.js.map